<template>
  <q-dialog ref="dialog"
            persistent
            class="q-pa-xl"
            no-esc-dismiss
            @hide="onDialogHide">

    <q-card class="q-pa-md category-box">
      <q-card-section>
        <div class="text-h6">{{ $t('settings.reorder.h1') }}</div>
        <div class="text-caption text-grey-6">{{ $t('settings.reorder.hint')}}</div>
      </q-card-section>

      <q-card-section class="" style="overflow: scroll">
        <draggable v-model="categoryData"
                   ghost-class="ghost">
          <q-card v-for="ctg in categoryData" :key="ctg._id"
                  bordered class="cursor-pointer">
            <q-card-section><q-icon name="fas fa-ellipsis-v" class="text-grey-5 q-mr-sm"/>
              {{ ctg.name + (ctg.extra ? '' : ` (${ctg.ageTo} - ${ctg.ageFrom})`) }}
            </q-card-section>
          </q-card>
        </draggable>
      </q-card-section>

      <q-card-actions align="right">
        <q-btn class="q-mr-md" :label="$t('default.save')" color="positive" @click="onOKClick" />
        <q-btn class="q-mr-xl" :label="$t('default.cancel')" color="primary" @click="onCancelClick" />
      </q-card-actions>
    </q-card>
  </q-dialog>
</template>

<script setup lang="js">
import log from 'src/service/messaging-service';
import draggable from 'vuedraggable';
import {onMounted, reactive, ref} from 'vue';

const $t = log.getI18n();
const ipcMain = window.ipcMain;

const categoryData = reactive([]);
const dialog = ref(null);

// function show() {
//   debugger;
//   dialog.value.show();
// }

function hide() {
  dialog.value.hide();
}

async function ctgLoadFromDb() {
  const response = await ipcMain.send('category-get-all-data');
  if (response.status === 'fail') log.error(response.message);
  else {
    categoryData.splice(0, categoryData.length, ...response.message);
  }
}

async function onOKClick() {
  categoryData.forEach((ctg, index) => { ctg.rank = index + 1; });
  const response = await ipcMain.send('category-save-all-ranks', categoryData);
  if (response.status === 'fail') log.error(response.message);
  else {
    log.info($t('settings.categories.reorderSuccess'));

    this.$emit('ok');
    this.$emit('hide');
  }
}

function onCancelClick() {
  hide();
}

function onDialogHide() {
  this.$emit('hide');
}

onMounted(() => {
  // once mounted, we need to trigger the initial server data fetch
  ctgLoadFromDb();
})
</script>

<style lang="scss">
  @import "../css/quasar.variables";
  .ghost {
    opacity: 0.5;
    background: $primary-shadow;
  }

  .category-box {
    width: 500px;
    display: flex;
    flex-direction: column;
  }
</style>
